﻿using System.Diagnostics;
using System.Threading;
using System.Xml;
using ff14bot;
using ff14bot.Behavior;
using ff14bot.Enums;
using ff14bot.Helpers;
using ff14bot.Interfaces;
using ff14bot.Managers;
using ff14bot.Navigation;
using ff14bot.Objects;
using Clio.Utilities;
using System;
using System.Collections.Generic;
using System.IO;
using System.Configuration;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Timers;
using System.Windows.Forms;
using TreeSharp;

using Action = TreeSharp.Action;

namespace Position
{
    public class Position : IBotPlugin
    {
        #region Initialization Information
        public string Author { get { return "Name here"; } }
        public string Description { get { return "Get player position string"; } }
        public Version Version { get { return new Version(0, 0, 0); } }
        public string Name { get { return "Position"; } }

        public bool WantButton
        {
            get { return true; }
        }
        public string ButtonText
        {
            get { return "Get Position"; }
        }
        public void OnButtonPress()
        {
            ToggleRBConsole();
        }

        internal Thread _guiThread;
        public void ToggleRBConsole()
        {
            if (_guiThread == null || !_guiThread.IsAlive)
            {
                _guiThread = new Thread(() => new Position_Form().ShowDialog()) { IsBackground = true };
                _guiThread.SetApartmentState(ApartmentState.STA);
                _guiThread.Start();
            }
            else
            {
                _guiThread.Abort();
            }
        }

        public bool Equals(IBotPlugin other)
        {
            throw new NotImplementedException();
        }
        #endregion

        private Position_Form _form;

        #region Init
        public void OnInitialize()
        {

        }
        public void OnShutdown()
        {

        }
        public void OnEnabled()
        {
            Logging.Write("[Position] Enabled");
        }
        public void OnDisabled()
        {
            Logging.Write("[Position] Disabled");
        }
        #endregion

        public static void Use(string itemname)
        {

        }

        #region Pulse
        public void OnPulse()
        {

        }
        #endregion
    }
}